<?php
    namespace poony_plugin;

/**
 * Setting class Poony
 */


class SettingsPoony{

    function __construct(){
        add_action('admin_menu', array($this, 'add_poony_settings_page'));
        add_action('admin_init', array($this, 'add_admin_poony_settings_cb'));
    }

    public function add_poony_settings_page(){
        add_options_page(
            'PoonySettings',
            'PoonySettings',
            'manage_options',
            'poony_settings_admin',
            array($this, 'poony_settings_page_content'),
            60
        );
    }

    public function poony_settings_page_content(){
        include POONY_PLUGIN_PATH.'/templates/poony-admin-settings.php';
    }

    public function add_admin_poony_settings_cb(){
        /*
         1. add setting section
         2. add setting field
         3. register setting
         */

        /**===============================================
        1. add setting section
        ================================================= */
        add_settings_section(
            'poony_admin_section_id',                       // $id
            'Impostazioni generali',                        // $title
            array($this,'add_settings_section_cb'),         // callback
            'poony_settings_admin_page'                     // $page
        );

        for ($i = 1; $i <= 5; $i++) {
            add_settings_section(
                'poony_admin_pickup_'.$i.'_section_id',                // $id
                'Punto di ritiro '.$i,                              // $title
                array($this,'add_pickup_section_cb'),           // callback
                'poony_settings_admin_page'                     // $page
            );
        }

        /**===============================================
        2. add setting field
        ================================================= */

        /**============= START Admin Settings ============= */
        add_settings_field(
            'poony_location_index_field',                      // $id
            'DB field per Multistore (Lasciare vuoto in caso di unico punto di ritiro)',                      // $title
            array($this,'add_field_cb'),                    // callback
            'poony_settings_admin_page',                    // $page
            'poony_admin_section_id',                       // $section
            array(
                'name' => 'poony_location_index_field',
                'id' => 'poony_location_index_field',
                'value' => get_option('poony_location_index_field'),
                'type' => 'text'
            )
        );
        add_settings_field(
            'poony_delivery_date_field',                      // $id
            'DB field per la data di consegna',                      // $title
            array($this,'add_field_cb'),                    // callback
            'poony_settings_admin_page',                    // $page
            'poony_admin_section_id',                       // $section
            array(
                'name' => 'poony_delivery_date_field',
                'id' => 'poony_delivery_date_field',
                'value' => get_option('poony_delivery_date_field'),
                'type' => 'text'
            )
        );
        add_settings_field(
            'poony_delivery_time_field',                      // $id
            'DB field per orario di consegna',              // $title
            array($this,'add_field_cb'),                    // callback
            'poony_settings_admin_page',                    // $page
            'poony_admin_section_id',                       // $section
            array(
                'name' => 'poony_delivery_time_field',
                'id' => 'poony_delivery_time_field',
                'value' => get_option('poony_delivery_time_field'),
                'type' => 'text'
            )
        );
        add_settings_field(
            'poony_delivery_note_field',                      // $id
            'DB billing field per note sulla consegna (es. billing_notes or billing_address_2)',              // $title
            array($this,'add_field_cb'),                    // callback
            'poony_settings_admin_page',                    // $page
            'poony_admin_section_id',                       // $section
            array(
                'name' => 'poony_delivery_note_field',
                'id' => 'poony_delivery_note_field',
                'value' => get_option('poony_delivery_note_field'),
                'type' => 'text'
            )
        );
        /**============= END Admin Settings ============= */

        for ($i = 1; $i <= 5; $i++) {
            /**============= START Pickup i ============= */
            add_settings_field(
                'poony_base_url_pickup_'.$i,                               // $id
                'Poony Base Url',                               // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',              // $section
                array(
                    'name' => 'poony_base_url_pickup_'.$i,
                    'id' => 'poony_base_url_pickup_'.$i,
                    'value' => get_option('poony_base_url_pickup_'.$i),
                    'type' => 'text'
                )
            );
            add_settings_field(
                'poony_usr_pickup_'.$i,                                    // $id
                'Poony Username',                               // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',              // $section
                array(
                    'name' => 'poony_usr_pickup_'.$i,
                    'id' => 'poony_usr_pickup_'.$i,
                    'value' => get_option('poony_usr_pickup_'.$i),
                    'type' => 'text'
                )
            );
            add_settings_field(
                'poony_pw_pickup_'.$i,                                     // $id
                'Poony Password',                               // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',              // $section
                array(
                    'name' => 'poony_pw_pickup_'.$i,
                    'id' => 'poony_pw_pickup_'.$i,
                    'value' => get_option('poony_pw_pickup_'.$i),
                    'type' => 'password'
                )
            );
            add_settings_field(
                'poony_auto_assignment_pickup_'.$i,                               // $id
                'Poony Assegna Automaticamente ai Preferiti',                               // $title
                array($this,'add_field_checkbox_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                       // $section
                array(
                    'name' => 'poony_auto_assignment_pickup_'.$i,
                    'id' => 'poony_auto_assignment_pickup_'.$i,
                    'value' => get_option('poony_auto_assignment_pickup_'.$i),
                    'type' => 'checkbox'
                )
            );
            add_settings_field(
                'poony_send_notification_pickup_'.$i,                               // $id
                'Poony Invia Notifiche',                               // $title
                array($this,'add_field_checkbox_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                       // $section
                array(
                    'name' => 'poony_send_notification_pickup_'.$i,
                    'id' => 'poony_send_notification_pickup_'.$i,
                    'value' => get_option('poony_send_notification_pickup_'.$i),
                    'type' => 'checkbox'
                )
            );
            add_settings_field(
                'poony_to_print_pickup_'.$i,                               // $id
                'Poony Stampa Ordine',                               // $title
                array($this,'add_field_checkbox_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                       // $section
                array(
                    'name' => 'poony_to_print_pickup_'.$i,
                    'id' => 'poony_to_print_pickup_'.$i,
                    'value' => get_option('poony_to_print_pickup_'.$i),
                    'type' => 'checkbox'
                )
            );
            add_settings_field(
                'poony_location_code_pickup_'.$i,                               // $id
                'Poony Codice Sede',                               // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                       // $section
                array(
                    'name' => 'poony_location_code_pickup_'.$i,
                    'id' => 'poony_location_code_pickup_'.$i,
                    'value' => get_option('poony_location_code_pickup_'.$i),
                    'type' => 'text'
                )
            );

            add_settings_field(
                'poony_time_zone_name_pickup_'.$i,                               // $id
                'Poony Time Zone (es. Europe/Rome)',                               // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                       // $section
                array(
                    'name' => 'poony_time_zone_name_pickup_'.$i,
                    'id' => 'poony_time_zone_name_pickup_'.$i,
                    'value' => get_option('poony_time_zone_name_pickup_'.$i),
                    'type' => 'text'
                )
            );
            add_settings_field(
                'poony_store_name_pickup_'.$i,                             // $id
                'Nome punto di ritiro',                         // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                // $section
                array(
                    'name' => 'poony_store_name_pickup_'.$i,
                    'id' => 'poony_store_name_pickup_'.$i,
                    'value' => get_option('poony_store_name_pickup_'.$i),
                    'type' => 'text'
                )
            );

            add_settings_field(
                'poony_store_care_of_pickup_'.$i,                          // $id
                'Referente',                                    // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                // $section
                array(
                    'name' => 'poony_store_care_of_pickup_'.$i,
                    'id' => 'poony_store_care_of_pickup_'.$i,
                    'value' => get_option('poony_store_care_of_pickup_'.$i),
                    'type' => 'text'
                )
            );

            add_settings_field(
                'poony_store_phone_pickup_'.$i,                          // $id
                'Numero di telefono',                            // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                // $section
                array(
                    'name' => 'poony_store_phone_pickup_'.$i,
                    'id' => 'poony_store_phone_pickup_'.$i,
                    'value' => get_option('poony_store_phone_pickup_'.$i),
                    'type' => 'text'
                )
            );

            add_settings_field(
                'poony_store_city_pickup_'.$i,                             // $id
                'Città',                                        // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                // $section
                array(
                    'name' => 'poony_store_city_pickup_'.$i,
                    'id' => 'poony_store_city_pickup_'.$i,
                    'value' => get_option('poony_store_city_pickup_'.$i),
                    'type' => 'text'
                )
            );

            add_settings_field(
                'poony_store_country_pickup_'.$i,                          // $id
                'Paese',                            // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                // $section
                array(
                    'name' => 'poony_store_country_pickup_'.$i,
                    'id' => 'poony_store_country_pickup_'.$i,
                    'value' => get_option('poony_store_country_pickup_'.$i),
                    'type' => 'text'
                )
            );

            add_settings_field(
                'poony_store_postal_code_pickup_'.$i,                          // $id
                'CAP',                            // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                // $section
                array(
                    'name' => 'poony_store_postal_code_pickup_'.$i,
                    'id' => 'poony_store_postal_code_pickup_'.$i,
                    'value' => get_option('poony_store_postal_code_pickup_'.$i),
                    'type' => 'text'
                )
            );

            add_settings_field(
                'poony_store_province_pickup_'.$i,                          // $id
                'Provincia',                            // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                // $section
                array(
                    'name' => 'poony_store_province_pickup_'.$i,
                    'id' => 'poony_store_province_pickup_'.$i,
                    'value' => get_option('poony_store_province_pickup_'.$i),
                    'type' => 'text'
                )
            );

            add_settings_field(
                'poony_store_address_pickup_'.$i,                          // $id
                'Indirizzo',                            // $title
                array($this,'add_field_cb'),                    // callback
                'poony_settings_admin_page',                    // $page
                'poony_admin_pickup_'.$i.'_section_id',                // $section
                array(
                    'name' => 'poony_store_address_pickup_'.$i,
                    'id' => 'poony_store_address_pickup_'.$i,
                    'value' => get_option('poony_store_address_pickup_'.$i),
                    'type' => 'text'
                )
            );
            /**============= END Pickup i ============= */
        }

        /**===============================================
        3. register setting
        ================================================= */

        /**============= START Admin Settings ============= */
        register_setting(
            'poony_settings_admin_page_group',              // $option_group
            'poony_location_index_field',                   // $option_name
            array(                                          // $args
                'sanitize_callback'=> 'sanitize_text_field'
            )
        );
        register_setting(
            'poony_settings_admin_page_group',              // $option_group
            'poony_delivery_date_field',                   // $option_name
            array(                                          // $args
                'sanitize_callback'=> 'sanitize_text_field'
            )
        );
        register_setting(
            'poony_settings_admin_page_group',              // $option_group
            'poony_delivery_time_field',                   // $option_name
            array(                                          // $args
                'sanitize_callback'=> 'sanitize_text_field'
            )
        );
        register_setting(
            'poony_settings_admin_page_group',              // $option_group
            'poony_delivery_note_field',                   // $option_name
            array(                                          // $args
                'sanitize_callback'=> 'sanitize_text_field'
            )
        );
        /**============= END Admin Settings ============= */

        /**============= START Pickup i ============= */
        for ($i = 1; $i <= 5; $i++) {

            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_base_url_pickup_'.$i,                                    // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );
            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_usr_pickup_'.$i,                                     // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );
            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_pw_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );

            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_auto_assignment_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );

            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_send_notification_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );

            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_to_print_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );

            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_location_code_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );

            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_time_zone_name_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );

            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_store_name_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );
            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_store_care_of_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );
            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_store_phone_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );
            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_store_city_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );

            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_store_country_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );
            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_store_postal_code_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );

            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_store_province_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );
            register_setting(
                'poony_settings_admin_page_group',              // $option_group
                'poony_store_address_pickup_'.$i,                               // $option_name
                array(                                          // $args
                    'sanitize_callback' => 'sanitize_text_field'
                )
            );
        }
        /**============= END Pickup i ============= */
    }

    /*
     * callback add_settings_section
     */
    public function add_settings_section_cb(){
        return null;
    }

    /*
     * callback add_settings_section
     */
    public function add_pickup_section_cb(){
        return null;
    }

    /*
     * callback add_field_text_cb
     */
    public function add_field_cb($args){
        $name = (isset($args['name'])) ? $args['name'] : '';
        $value = (isset($args['value'])) ? $args['value'] : '';
        $id = (isset($args['id'])) ? $args['id'] : '';
        $type = (isset($args['type'])) ? $args['type'] : '';
        ?>
        <input style="width: 50%;" type="<?php echo $type?>" id="<?php echo $id?>" name="<?php echo $name?>" value="<?php echo $value?>">
        <?php
    }

    /*
     * callback add_field_checkbox_cb
     */
    public function add_field_checkbox_cb($args){
        $name = (isset($args['name'])) ? $args['name'] : '';
        $value = (isset($args['value'])) ? $args['value'] : '';
        $id = (isset($args['id'])) ? $args['id'] : '';
        $type = (isset($args['type'])) ? $args['type'] : '';
        ?>
        <input type="<?php echo $type?>" id="<?php echo $id?>" name="<?php echo $name?>" value="1" <?php checked(1, $value, true); ?>>
        <?php
    }
}